/**
 * <copyright>
 * </copyright>
 *
 * $Id: ComponentApiType.java,v 1.1 2005/01/20 12:03:03 ryman Exp $
 */
package org.eclipse.component.api;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component Api Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.component.api.ComponentApiType#getInternalApis <em>Internal Apis</em>}</li>
 *   <li>{@link org.eclipse.component.api.ComponentApiType#getExternalApis <em>External Apis</em>}</li>
 *   <li>{@link org.eclipse.component.api.ComponentApiType#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.component.api.ComponentApiType#getVersion <em>Version</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.component.api.ApiPackage#getComponentApiType()
 * @model 
 * @generated
 */
public interface ComponentApiType extends EObject
{
  /**
   * Returns the value of the '<em><b>Internal Apis</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Internal Apis</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Internal Apis</em>' containment reference.
   * @see #setInternalApis(ApiTypes)
   * @see org.eclipse.component.api.ApiPackage#getComponentApiType_InternalApis()
   * @model containment="true" resolveProxies="false" required="true"
   * @generated
   */
  ApiTypes getInternalApis();

  /**
   * Sets the value of the '{@link org.eclipse.component.api.ComponentApiType#getInternalApis <em>Internal Apis</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Internal Apis</em>' containment reference.
   * @see #getInternalApis()
   * @generated
   */
  void setInternalApis(ApiTypes value);

  /**
   * Returns the value of the '<em><b>External Apis</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>External Apis</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>External Apis</em>' containment reference.
   * @see #setExternalApis(ApiTypes)
   * @see org.eclipse.component.api.ApiPackage#getComponentApiType_ExternalApis()
   * @model containment="true" resolveProxies="false" required="true"
   * @generated
   */
  ApiTypes getExternalApis();

  /**
   * Sets the value of the '{@link org.eclipse.component.api.ComponentApiType#getExternalApis <em>External Apis</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>External Apis</em>' containment reference.
   * @see #getExternalApis()
   * @generated
   */
  void setExternalApis(ApiTypes value);

  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * 						The component name; e.g. "Eclipse Platform
   * 						Generic Workbench"; note that this name is used
   * 						to refer to the component and distinguish it
   * 						from other components (but otherwise has no
   * 						official status in Eclipse ontology)
   * 					
   * <!-- end-model-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.eclipse.component.api.ApiPackage#getComponentApiType_Name()
   * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.eclipse.component.api.ComponentApiType#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Version</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Version</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Version</em>' attribute.
   * @see #setVersion(String)
   * @see org.eclipse.component.api.ApiPackage#getComponentApiType_Version()
   * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
   * @generated
   */
  String getVersion();

  /**
   * Sets the value of the '{@link org.eclipse.component.api.ComponentApiType#getVersion <em>Version</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Version</em>' attribute.
   * @see #getVersion()
   * @generated
   */
  void setVersion(String value);

} // ComponentApiType
