/**
 * <copyright>
 * </copyright>
 *
 * $Id: UsePackage.java,v 1.1 2005/01/20 12:03:03 ryman Exp $
 */
package org.eclipse.component.use;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.component.use.UseFactory
 * @generated
 */
public interface UsePackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "use";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://eclipse.org/component-use";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "use";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  UsePackage eINSTANCE = org.eclipse.component.use.impl.UsePackageImpl.init();

  /**
   * The meta object id for the '{@link org.eclipse.component.use.impl.ComponentUseTypeImpl <em>Component Use Type</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.component.use.impl.ComponentUseTypeImpl
   * @see org.eclipse.component.use.impl.UsePackageImpl#getComponentUseType()
   * @generated
   */
  int COMPONENT_USE_TYPE = 0;

  /**
   * The feature id for the '<em><b>Source Class</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_USE_TYPE__SOURCE_CLASS = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_USE_TYPE__NAME = 1;

  /**
   * The feature id for the '<em><b>Version</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_USE_TYPE__VERSION = 2;

  /**
   * The number of structural features of the the '<em>Component Use Type</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMPONENT_USE_TYPE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link org.eclipse.component.use.impl.DocumentRootImpl <em>Document Root</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.component.use.impl.DocumentRootImpl
   * @see org.eclipse.component.use.impl.UsePackageImpl#getDocumentRoot()
   * @generated
   */
  int DOCUMENT_ROOT = 1;

  /**
   * The feature id for the '<em><b>Mixed</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOCUMENT_ROOT__MIXED = 0;

  /**
   * The feature id for the '<em><b>XMLNS Prefix Map</b></em>' map.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOCUMENT_ROOT__XMLNS_PREFIX_MAP = 1;

  /**
   * The feature id for the '<em><b>XSI Schema Location</b></em>' map.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOCUMENT_ROOT__XSI_SCHEMA_LOCATION = 2;

  /**
   * The feature id for the '<em><b>Component Use</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOCUMENT_ROOT__COMPONENT_USE = 3;

  /**
   * The number of structural features of the the '<em>Document Root</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOCUMENT_ROOT_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link org.eclipse.component.use.impl.SourceClassImpl <em>Source Class</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.component.use.impl.SourceClassImpl
   * @see org.eclipse.component.use.impl.UsePackageImpl#getSourceClass()
   * @generated
   */
  int SOURCE_CLASS = 2;

  /**
   * The feature id for the '<em><b>Class Use</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOURCE_CLASS__CLASS_USE = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOURCE_CLASS__NAME = 1;

  /**
   * The number of structural features of the the '<em>Source Class</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOURCE_CLASS_FEATURE_COUNT = 2;


  /**
   * Returns the meta object for class '{@link org.eclipse.component.use.ComponentUseType <em>Component Use Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Component Use Type</em>'.
   * @see org.eclipse.component.use.ComponentUseType
   * @generated
   */
  EClass getComponentUseType();

  /**
   * Returns the meta object for the containment reference list '{@link org.eclipse.component.use.ComponentUseType#getSourceClass <em>Source Class</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Source Class</em>'.
   * @see org.eclipse.component.use.ComponentUseType#getSourceClass()
   * @see #getComponentUseType()
   * @generated
   */
  EReference getComponentUseType_SourceClass();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.component.use.ComponentUseType#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.eclipse.component.use.ComponentUseType#getName()
   * @see #getComponentUseType()
   * @generated
   */
  EAttribute getComponentUseType_Name();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.component.use.ComponentUseType#getVersion <em>Version</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Version</em>'.
   * @see org.eclipse.component.use.ComponentUseType#getVersion()
   * @see #getComponentUseType()
   * @generated
   */
  EAttribute getComponentUseType_Version();

  /**
   * Returns the meta object for class '{@link org.eclipse.component.use.DocumentRoot <em>Document Root</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Document Root</em>'.
   * @see org.eclipse.component.use.DocumentRoot
   * @generated
   */
  EClass getDocumentRoot();

  /**
   * Returns the meta object for the attribute list '{@link org.eclipse.component.use.DocumentRoot#getMixed <em>Mixed</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Mixed</em>'.
   * @see org.eclipse.component.use.DocumentRoot#getMixed()
   * @see #getDocumentRoot()
   * @generated
   */
  EAttribute getDocumentRoot_Mixed();

  /**
   * Returns the meta object for the map '{@link org.eclipse.component.use.DocumentRoot#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the map '<em>XMLNS Prefix Map</em>'.
   * @see org.eclipse.component.use.DocumentRoot#getXMLNSPrefixMap()
   * @see #getDocumentRoot()
   * @generated
   */
  EReference getDocumentRoot_XMLNSPrefixMap();

  /**
   * Returns the meta object for the map '{@link org.eclipse.component.use.DocumentRoot#getXSISchemaLocation <em>XSI Schema Location</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the map '<em>XSI Schema Location</em>'.
   * @see org.eclipse.component.use.DocumentRoot#getXSISchemaLocation()
   * @see #getDocumentRoot()
   * @generated
   */
  EReference getDocumentRoot_XSISchemaLocation();

  /**
   * Returns the meta object for the containment reference '{@link org.eclipse.component.use.DocumentRoot#getComponentUse <em>Component Use</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Component Use</em>'.
   * @see org.eclipse.component.use.DocumentRoot#getComponentUse()
   * @see #getDocumentRoot()
   * @generated
   */
  EReference getDocumentRoot_ComponentUse();

  /**
   * Returns the meta object for class '{@link org.eclipse.component.use.SourceClass <em>Source Class</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Source Class</em>'.
   * @see org.eclipse.component.use.SourceClass
   * @generated
   */
  EClass getSourceClass();

  /**
   * Returns the meta object for the containment reference list '{@link org.eclipse.component.use.SourceClass#getClassUse <em>Class Use</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Class Use</em>'.
   * @see org.eclipse.component.use.SourceClass#getClassUse()
   * @see #getSourceClass()
   * @generated
   */
  EReference getSourceClass_ClassUse();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.component.use.SourceClass#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.eclipse.component.use.SourceClass#getName()
   * @see #getSourceClass()
   * @generated
   */
  EAttribute getSourceClass_Name();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  UseFactory getUseFactory();

} //UsePackage
