#!/bin/sh

source properties.shsource

if [ "$1" != "-doit" ] ; then
   echo "    This is a dry run. Add -doit to actually remove"
   doit="--dry-run"
else
   doit=""
fi

export FROM_UPDATE_SITE=~/downloads/webtools/milestones
export TO_UPDATE_SITE=~/downloads/webtools/updates_mirror

echo "Number of jars before cleaning: "
find ${FROM_UPDATE_SITE} -name "*.jar" | wc -l 

./ant.sh -f createMirrorSite.xml -Declipse.home=${eclipseLocation}

rsync $doit --delete --ignore-existing -rv ${TO_UPDATE_SITE}/plugins ${FROM_UPDATE_SITE}

rsync $doit --delete --ignore-existing -rv ${TO_UPDATE_SITE}/features ${FROM_UPDATE_SITE}

if [ "$doit" = "--dry-run" ] ; then
   echo "    This was a dry run. Add -doit to actually remove"
else
   echo "Number of jars after cleaning: "
   find ${FROM_UPDATE_SITE} -name "*.jar" | wc -l 
fi
