
# This script finds patterns of the old form of specifying modules, that
#     consist of a path name ending with a module name. We know the model name
#     should stay the same, so this is just to tweak the path names.
#     Thought to be useful for map files and Team Project Sets.

# Example use:
#     The easiest case, if only a few files
#                 sed -f sedscript.sed oldfile.pfs > newfile.pfs
#         Using the inplace option worked for me on Linux, but not
#     for me on Windows using Cygwin
#           sed -ibak -f sedscript.sed *.pfs
#     A classic form:
#                             find releng/maps/ -name *.map -exec sed -ibak -f sedscript.sed '{}' \;

s:jst/components/assembly/features/org.eclipse.jst.feature:webtools.releng/assembly/features/org.eclipse.jst.feature:g
s:jst/components/assembly/features/org.eclipse.jst.sdk:webtools.releng/assembly/features/org.eclipse.jst.sdk:g
s:jst/components/assembly/features/org.eclipse.jst.tests:webtools.releng/assembly/features/org.eclipse.jst.tests:g
s:jst/components/assembly/features/org.eclipse.wtp.patch.assembly.feature:webtools.releng/assembly/features/org.eclipse.wtp.patch.assembly.feature:g
s:jst/components/assembly/features/org.eclipse.wtp.patch.tests.assembly.feature:webtools.releng/assembly/features/org.eclipse.wtp.patch.tests.assembly.feature:g
s:jst/components/assembly/plugins/org.eclipse.jst:webtools.releng/assembly/plugins/org.eclipse.jst:g
s:jst/components/common/features/org.eclipse.jst.common_core.feature:common/features/org.eclipse.jst.common_core.feature:g
s:jst/components/common/features/org.eclipse.jst.common_sdk.feature:common/features/org.eclipse.jst.common_sdk.feature:g
s:jst/components/common/plugins/org.eclipse.jst.common.annotations.controller:jeetools/plugins/org.eclipse.jst.common.annotations.controller:g
s:jst/components/common/plugins/org.eclipse.jst.common.annotations.core:jeetools/plugins/org.eclipse.jst.common.annotations.core:g
s:jst/components/common/plugins/org.eclipse.jst.common.annotations.ui:jeetools/plugins/org.eclipse.jst.common.annotations.ui:g
s:jst/components/common/plugins/org.eclipse.jst.common.frameworks:jeetools/plugins/org.eclipse.jst.common.frameworks:g
s:jst/components/common/plugins/org.eclipse.jst.common.project.facet.core:common/plugins/org.eclipse.jst.common.project.facet.core:g
s:jst/components/doc/features/org.eclipse.jst.doc.isv.feature:jeetools/features/org.eclipse.jst.doc.isv.feature:g
s:jst/components/doc/features/org.eclipse.jst.doc.user.feature:jeetools/features/org.eclipse.jst.doc.user.feature:g
s:jst/components/doc/plugins/org.eclipse.jst.doc.isv:jeetools/docs/org.eclipse.jst.doc.isv:g
s:jst/components/doc/plugins/org.eclipse.jst.ejb.doc.user:ejbtools/docs/org.eclipse.jst.ejb.doc.user:g
s:jst/components/doc/plugins/org.eclipse.jst.j2ee.doc.user:jeetools/docs/org.eclipse.jst.j2ee.doc.user:g
s:jst/components/doc/plugins/org.eclipse.jst.j2ee.infopop:jeetools/docs/org.eclipse.jst.j2ee.infopop:g
s:jst/components/doc/plugins/org.eclipse.jst.jsp.ui.infopop:sourceediting/docs/org.eclipse.jst.jsp.ui.infopop:g
s:jst/components/doc/plugins/org.eclipse.jst.server.ui.doc.user:servertools/docs/org.eclipse.jst.server.ui.doc.user:g
s:jst/components/doc/plugins/org.eclipse.jst.server.ui.infopop:servertools/docs/org.eclipse.jst.server.ui.infopop:g
s:jst/components/doc/plugins/org.eclipse.jst.servlet.ui.infopop:jeetools/docs/org.eclipse.jst.servlet.ui.infopop:g
s:jst/components/doc/plugins/org.eclipse.jst.ws.axis.infopop:webservices/docs/org.eclipse.jst.ws.axis.infopop:g
s:jst/components/doc/plugins/org.eclipse.jst.ws.axis.ui.doc.user:webservices/docs/org.eclipse.jst.ws.axis.ui.doc.user:g
s:jst/components/doc/plugins/org.eclipse.jst.ws.consumption.infopop:webservices/docs/org.eclipse.jst.ws.consumption.infopop:g
s:jst/components/doc/plugins/org.eclipse.jst.ws.consumption.ui.doc.user:webservices/docs/org.eclipse.jst.ws.consumption.ui.doc.user:g
s:jst/components/doc/plugins/org.eclipse.jst.ws.doc.user:webservices/docs/org.eclipse.jst.ws.doc.user:g
s:jst/components/doc/plugins/org.eclipse.jst.ws.infopop:webservices/docs/org.eclipse.jst.ws.infopop:g
s:jst/components/ejb/features/org.eclipse.jst.enterprise_core.feature:jeetools/features/org.eclipse.jst.enterprise_core.feature:g
s:jst/components/ejb/features/org.eclipse.jst.enterprise_core.feature.patch:jeetools/features/org.eclipse.jst.enterprise_core.feature.patch:g
s:jst/components/ejb/features/org.eclipse.jst.enterprise_sdk.feature:jeetools/features/org.eclipse.jst.enterprise_sdk.feature:g
s:jst/components/ejb/features/org.eclipse.jst.enterprise_tests.feature:jeetools/features/org.eclipse.jst.enterprise_tests.feature:g
s:jst/components/ejb/features/org.eclipse.jst.enterprise_ui.feature:jeetools/features/org.eclipse.jst.enterprise_ui.feature:g
s:jst/components/ejb/features/org.eclipse.jst.enterprise_ui.feature.patch:jeetools/features/org.eclipse.jst.enterprise_ui.feature.patch:g
s:jst/components/ejb/features/org.eclipse.jst.enterprise_userdoc.feature:jeetools/features/org.eclipse.jst.enterprise_userdoc.feature:g
s:jst/components/ejb/plugins/org.eclipse.jst.ejb.ui:ejbtools/plugins/org.eclipse.jst.ejb.ui:g
s:jst/components/ejb/plugins/org.eclipse.jst.j2ee.ejb.annotation.model:ejbtools/plugins/org.eclipse.jst.j2ee.ejb.annotation.model:g
s:jst/components/ejb/plugins/org.eclipse.jst.j2ee.ejb.annotations.emitter:ejbtools/plugins/org.eclipse.jst.j2ee.ejb.annotations.emitter:g
s:jst/components/ejb/plugins/org.eclipse.jst.j2ee.ejb.annotations.ui:ejbtools/plugins/org.eclipse.jst.j2ee.ejb.annotations.ui:g
s:jst/components/ejb/plugins/org.eclipse.jst.j2ee.ejb.annotations.xdoclet:ejbtools/plugins/org.eclipse.jst.j2ee.ejb.annotations.xdoclet:g
s:jst/components/ejb/plugins/org.eclipse.jst.j2ee.xdoclet.runtime:ejbtools/plugins/org.eclipse.jst.j2ee.xdoclet.runtime:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee:jeetools/plugins/org.eclipse.jst.j2ee:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.core:jeetools/plugins/org.eclipse.jst.j2ee.core:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.ejb:ejbtools/plugins/org.eclipse.jst.j2ee.ejb:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.jca:jeetools/plugins/org.eclipse.jst.j2ee.jca:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.jca.ui:jeetools/plugins/org.eclipse.jst.j2ee.jca.ui:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.navigator.ui:jeetools/plugins/org.eclipse.jst.j2ee.navigator.ui:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.ui:jeetools/plugins/org.eclipse.jst.j2ee.ui:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.web:jeetools/plugins/org.eclipse.jst.j2ee.web:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.webservice:jeetools/plugins/org.eclipse.jst.j2ee.webservice:g
s:jst/components/j2ee/plugins/org.eclipse.jst.j2ee.webservice.ui:jeetools/plugins/org.eclipse.jst.j2ee.webservice.ui:g
s:jst/components/j2ee/plugins/org.eclipse.jst.jee:jeetools/plugins/org.eclipse.jst.jee:g
s:jst/components/j2ee/plugins/org.eclipse.jst.jee.ejb:ejbtools/plugins/org.eclipse.jst.jee.ejb:g
s:jst/components/j2ee/plugins/org.eclipse.jst.jee.ui:jeetools/plugins/org.eclipse.jst.jee.ui:g
s:jst/components/j2ee/plugins/org.eclipse.jst.jee.web:jeetools/plugins/org.eclipse.jst.jee.web:g
s:jst/components/j2ee/plugins/org.eclipse.jst.standard.schemas:sourceediting/plugins/org.eclipse.jst.standard.schemas:g
s:jst/components/j2ee/tests/org.eclipse.jst.j2ee.core.tests:jeetools/tests/org.eclipse.jst.j2ee.core.tests:g
s:jst/components/j2ee/tests/org.eclipse.jst.j2ee.core.tests.performance:jeetools/tests/org.eclipse.jst.j2ee.core.tests.performance:g
s:jst/components/j2ee/tests/org.eclipse.jst.j2ee.tests:jeetools/tests/org.eclipse.jst.j2ee.tests:g
s:jst/components/j2ee/tests/org.eclipse.jst.j2ee.tests.performance:jeetools/tests/org.eclipse.jst.j2ee.tests.performance:g
s:jst/components/j2ee/tests/org.eclipse.jst.validation.sample:jeetools/tests/org.eclipse.jst.validation.sample:g
s:jst/components/j2ee/tests/org.eclipse.jst.validation.test:jeetools/tests/org.eclipse.jst.validation.test:g
s:jst/components/jem/org.eclipse.jem:jeetools/plugins/org.eclipse.jem:g
s:jst/components/jem/org.eclipse.jem-feature:jeetools/features/org.eclipse.jem-feature:g
s:jst/components/jem/org.eclipse.jem-feature/com.ibm.etools.emf.event:jeetools/features/org.eclipse.jem-feature/com.ibm.etools.emf.event:g
s:jst/components/jem/org.eclipse.jem-feature/org.eclipse.jem.sdk:jeetools/features/org.eclipse.jem-feature/org.eclipse.jem.sdk:g
s:jst/components/jem/org.eclipse.jem-feature/org.eclipse.jem.sdk-feature:jeetools/features/org.eclipse.jem-feature/org.eclipse.jem.sdk-feature:g
s:jst/components/jem/org.eclipse.jem.beaninfo:jeetools/plugins/org.eclipse.jem.beaninfo:g
s:jst/components/jem/org.eclipse.jem.proxy:jeetools/plugins/org.eclipse.jem.proxy:g
s:jst/components/jem/org.eclipse.jem.ui:jeetools/plugins/org.eclipse.jem.ui:g
s:jst/components/jem/org.eclipse.jem.util:common/plugins/org.eclipse.jem.util:g
s:jst/components/jem/org.eclipse.jem.workbench:jeetools/plugins/org.eclipse.jem.workbench:g
s:jst/components/jem/tests/org.eclipse.jem.tests:jeetools/tests/org.eclipse.jem.tests:g
s:jst/components/jem/tests/org.eclipse.jem.tests-feature:jeetools/features/org.eclipse.jem.tests-feature:g
s:jst/components/jsp/features/org.eclipse.jst.web_core.feature:sourceediting/features/org.eclipse.jst.web_core.feature:g
s:jst/components/jsp/features/org.eclipse.jst.web_core.feature.patch:sourceediting/features/org.eclipse.jst.web_core.feature.patch:g
s:jst/components/jsp/features/org.eclipse.jst.web_sdk.feature:sourceediting/features/org.eclipse.jst.web_sdk.feature:g
s:jst/components/jsp/features/org.eclipse.jst.web_tests.feature:sourceediting/features/org.eclipse.jst.web_tests.feature:g
s:jst/components/jsp/features/org.eclipse.jst.web_ui.feature:sourceediting/features/org.eclipse.jst.web_ui.feature:g
s:jst/components/jsp/features/org.eclipse.jst.web_userdoc.feature:sourceediting/features/org.eclipse.jst.web_userdoc.feature:g
s:jst/components/jsp/plugins/org.eclipse.jst.jsp.core:sourceediting/plugins/org.eclipse.jst.jsp.core:g
s:jst/components/jsp/plugins/org.eclipse.jst.jsp.ui:sourceediting/plugins/org.eclipse.jst.jsp.ui:g
s:jst/components/jsp/tests/org.eclipse.jst.jsp.core.tests:sourceediting/tests/org.eclipse.jst.jsp.core.tests:g
s:jst/components/jsp/tests/org.eclipse.jst.jsp.tests.encoding:sourceediting/tests/org.eclipse.jst.jsp.tests.encoding:g
s:jst/components/jsp/tests/org.eclipse.jst.jsp.ui.tests:sourceediting/tests/org.eclipse.jst.jsp.ui.tests:g
s:jst/components/jsp/tests/org.eclipse.jst.jsp.ui.tests.performance:sourceediting/tests/org.eclipse.jst.jsp.ui.tests.performance:g
s:jst/components/server/features/org.eclipse.jst.server_adapters.feature:servertools/features/org.eclipse.jst.server_adapters.feature:g
s:jst/components/server/features/org.eclipse.jst.server_adapters.sdk.feature:servertools/features/org.eclipse.jst.server_adapters.sdk.feature:g
s:jst/components/server/features/org.eclipse.jst.server_core.feature:servertools/features/org.eclipse.jst.server_core.feature:g
s:jst/components/server/features/org.eclipse.jst.server_sdk.feature:servertools/features/org.eclipse.jst.server_sdk.feature:g
s:jst/components/server/features/org.eclipse.jst.server_tests.feature:servertools/features/org.eclipse.jst.server_tests.feature:g
s:jst/components/server/features/org.eclipse.jst.server_ui.feature:servertools/features/org.eclipse.jst.server_ui.feature:g
s:jst/components/server/features/org.eclipse.jst.server_userdoc.feature:servertools/features/org.eclipse.jst.server_userdoc.feature:g
s:jst/components/server/plugins/org.eclipse.jst.server.core:servertools/plugins/org.eclipse.jst.server.core:g
s:jst/components/server/plugins/org.eclipse.jst.server.generic.core:servertools/plugins/org.eclipse.jst.server.generic.core:g
s:jst/components/server/plugins/org.eclipse.jst.server.generic.jboss:servertools/plugins/org.eclipse.jst.server.generic.jboss:g
s:jst/components/server/plugins/org.eclipse.jst.server.generic.jonas:servertools/plugins/org.eclipse.jst.server.generic.jonas:g
s:jst/components/server/plugins/org.eclipse.jst.server.generic.oc4j:servertools/plugins/org.eclipse.jst.server.generic.oc4j:g
s:jst/components/server/plugins/org.eclipse.jst.server.generic.ui:servertools/plugins/org.eclipse.jst.server.generic.ui:g
s:jst/components/server/plugins/org.eclipse.jst.server.generic.weblogic:servertools/plugins/org.eclipse.jst.server.generic.weblogic:g
s:jst/components/server/plugins/org.eclipse.jst.server.installable:servertools/plugins/org.eclipse.jst.server.installable:g
s:jst/components/server/plugins/org.eclipse.jst.server.preview.adapter:servertools/plugins/org.eclipse.jst.server.preview.adapter:g
s:jst/components/server/plugins/org.eclipse.jst.server.tomcat.core:servertools/plugins/org.eclipse.jst.server.tomcat.core:g
s:jst/components/server/plugins/org.eclipse.jst.server.tomcat.ui:servertools/plugins/org.eclipse.jst.server.tomcat.ui:g
s:jst/components/server/plugins/org.eclipse.jst.server.ui:servertools/plugins/org.eclipse.jst.server.ui:g
s:jst/components/server/plugins/org.eclipse.jst.server.websphere.core:servertools/plugins/org.eclipse.jst.server.websphere.core:g
s:jst/components/server/tests/org.eclipse.jst.server.core.tests:servertools/tests/org.eclipse.jst.server.core.tests:g
s:jst/components/server/plugins/org.eclipse.jst.server.generic.tests:servertools/plugins/org.eclipse.jst.server.generic.tests:g
s:jst/components/server/tests/org.eclipse.jst.server.generic.tests:servertools/tests/org.eclipse.jst.server.generic.tests:g
s:jst/components/server/tests/org.eclipse.jst.server.tomcat.core.tests:servertools/tests/org.eclipse.jst.server.tomcat.core.tests:g
s:jst/components/server/tests/org.eclipse.jst.server.tomcat.tests.performance:servertools/tests/org.eclipse.jst.server.tomcat.tests.performance:g
s:jst/components/server/tests/org.eclipse.jst.server.tomcat.ui.tests:servertools/tests/org.eclipse.jst.server.tomcat.ui.tests:g
s:jst/components/server/tests/org.eclipse.jst.server.ui.tests:servertools/tests/org.eclipse.jst.server.ui.tests:g
s:jst/components/server/thirdparty/org.apache.cactus:servertools/thirdparty/org.apache.cactus:g
s:jst/components/servlet/plugins/org.eclipse.jst.servlet.ui:jeetools/plugins/org.eclipse.jst.servlet.ui:g
s:jst/components/servlet/tests/org.eclipse.jst.servlet.tests:jeetools/tests/org.eclipse.jst.servlet.tests:g
s:jst/components/web/features/org.eclipse.jst.webpageeditor.feature:org.eclipse.jsf/components/jsf/features/org.eclipse.jst.webpageeditor.feature:g
s:jst/components/web/features/org.eclipse.jst.webpageeditor_sdk.feature:org.eclipse.jsf/components/jsf/features/org.eclipse.jst.webpageeditor_sdk.feature:g
s:jst/components/ws/plugins/org.eclipse.jst.ws:webservices/plugins/org.eclipse.jst.ws:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis.consumption.core:webservices/plugins/org.eclipse.jst.ws.axis.consumption.core:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis.consumption.ui:webservices/plugins/org.eclipse.jst.ws.axis.consumption.ui:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis.creation.ui:webservices/plugins/org.eclipse.jst.ws.axis.creation.ui:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis2.consumption.core:webservices/plugins/org.eclipse.jst.ws.axis2.consumption.core:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis2.consumption.ui:webservices/plugins/org.eclipse.jst.ws.axis2.consumption.ui:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis2.core:webservices/plugins/org.eclipse.jst.ws.axis2.core:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis2.creation.core:webservices/plugins/org.eclipse.jst.ws.axis2.creation.core:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis2.creation.ui:webservices/plugins/org.eclipse.jst.ws.axis2.creation.ui:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.axis2.ui:webservices/plugins/org.eclipse.jst.ws.axis2.ui:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.consumption:webservices/plugins/org.eclipse.jst.ws.consumption:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.consumption.ui:webservices/plugins/org.eclipse.jst.ws.consumption.ui:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.creation.ejb.ui:webservices/plugins/org.eclipse.jst.ws.creation.ejb.ui:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.creation.ui:webservices/plugins/org.eclipse.jst.ws.creation.ui:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.uddiregistry:webservices/plugins/org.eclipse.jst.ws.uddiregistry:g
s:jst/components/ws/plugins/org.eclipse.jst.ws.ui:webservices/plugins/org.eclipse.jst.ws.ui:g
s:jst/components/ws/tests/org.eclipse.jst.ws.axis.consumption.core.tests:webservices/tests/org.eclipse.jst.ws.axis.consumption.core.tests:g
s:jst/components/ws/tests/org.eclipse.jst.ws.tests:webservices/tests/org.eclipse.jst.ws.tests:g
s:jst/components/ws/tests/org.eclipse.jst.ws.tests.performance:webservices/tests/org.eclipse.jst.ws.tests.performance:g
s:org.eclipse.wtp.releng.tests:webtools.releng/org.eclipse.wtp.releng.tests:g
s:org.eclipse.wtp/org.eclipse.wtp.releng.tests:webtools.releng/tests/org.eclipse.wtp.releng.tests:g
s:org.eclipse.wtp/org.eclipse.wtp.releng.tests.feature:webtools.releng/features/org.eclipse.wtp.releng.tests.feature:g
s:releng.wtptools/api/org.eclipse.wtp.releng.tools.component.core:webtools.releng/releng.wtptools/api/org.eclipse.wtp.releng.tools.component.core:g
s:releng.wtptools/api/org.eclipse.wtp.releng.tools.component.ui:webtools.releng/releng.wtptools/api/org.eclipse.wtp.releng.tools.component.ui:g
s:releng.wtpbuilder/tools/org.eclipse.wtp.releng.wtpbuilder:webtools.releng/releng.wtpbuilder/tools/org.eclipse.wtp.releng.wtpbuilder:g
s:releng.wtptools/api/org.eclipse.wtp.releng.wtpbuilder:webtools.releng/releng.wtptools/api/org.eclipse.wtp.releng.wtpbuilder:g
s:releng.wtpbuilder/tools/org.eclipse.wtp.releng.tools:webtools.releng/releng.wtpbuilder/tools/org.eclipse.wtp.releng.tools:g
s:releng.builder/tools/org.eclipse.wtp.releng.tools:webtools.releng/releng.builder/tools/org.eclipse.wtp.releng.tools:g
s:releng.wtptools/org.eclipse.wtp.releng.tools:webtools.releng/releng.wtptools/org.eclipse.wtp.releng.tools:g
s:wst/components/assembly/features/org.apache.axis.feature:webtools.releng/assembly/features/org.apache.axis.feature:g
s:wst/components/assembly/features/org.apache.commons_logging.feature:webtools.releng/assembly/features/org.apache.commons_logging.feature:g
s:wst/components/assembly/features/org.apache.jakarta_log4j.feature:webtools.releng/assembly/features/org.apache.jakarta_log4j.feature:g
s:wst/components/assembly/features/org.apache.wsil4j.feature:webtools.releng/assembly/features/org.apache.wsil4j.feature:g
s:wst/components/assembly/features/org.eclipse.wst.feature:webtools.releng/assembly/features/org.eclipse.wst.feature:g
s:wst/components/assembly/features/org.eclipse.wst.sdk:webtools.releng/assembly/features/org.eclipse.wst.sdk:g
s:wst/components/assembly/features/org.eclipse.wst.tests.feature:webtools.releng/assembly/features/org.eclipse.wst.tests.feature:g
s:wst/components/assembly/features/org.uddi4j.feature:webtools.releng/assembly/features/org.uddi4j.feature:g
s:wst/components/assembly/features/org.wsdl4j.feature:webtools.releng/assembly/features/org.wsdl4j.feature:g
s:wst/components/assembly/plugins/org.eclipse.wst:webtools.releng/assembly/plugins/org.eclipse.wst:g
s:wst/components/command/plugins/org.eclipse.wst.command.env:common/plugins/org.eclipse.wst.command.env:g
s:wst/components/command/plugins/org.eclipse.wst.command.env.core:common/plugins/org.eclipse.wst.command.env.core:g
s:wst/components/command/plugins/org.eclipse.wst.command.env.ui:common/plugins/org.eclipse.wst.command.env.ui:g
s:wst/components/common/features/org.eclipse.wst.common_core.feature:common/features/org.eclipse.wst.common_core.feature:g
s:wst/components/common/features/org.eclipse.wst.common_core.feature.patch:common/features/org.eclipse.wst.common_core.feature.patch:g
s:wst/components/common/features/org.eclipse.wst.common_sdk.feature:common/features/org.eclipse.wst.common_sdk.feature:g
s:wst/components/common/features/org.eclipse.wst.common_tests.feature:common/features/org.eclipse.wst.common_tests.feature:g
s:wst/components/common/features/org.eclipse.wst.common_ui.feature:common/features/org.eclipse.wst.common_ui.feature:g
s:wst/components/common/features/org.eclipse.wst.common_userdoc.feature:common/features/org.eclipse.wst.common_userdoc.feature:g
s:wst/components/common/performance-tests/org.eclipse.wst.common.tests.performance:common/tests/org.eclipse.wst.common.tests.performance:g
s:wst/components/common/plugins/org.eclipse.wst.common.core:common/plugins/org.eclipse.wst.common.core:g
s:wst/components/common/plugins/org.eclipse.wst.common.emf:common/plugins/org.eclipse.wst.common.emf:g
s:wst/components/common/plugins/org.eclipse.wst.common.emfworkbench.integration:common/plugins/org.eclipse.wst.common.emfworkbench.integration:g
s:wst/components/common/plugins/org.eclipse.wst.common.environment:common/plugins/org.eclipse.wst.common.environment:g
s:wst/components/common/plugins/org.eclipse.wst.common.frameworks:common/plugins/org.eclipse.wst.common.frameworks:g
s:wst/components/common/plugins/org.eclipse.wst.common.frameworks.ui:common/plugins/org.eclipse.wst.common.frameworks.ui:g
s:wst/components/common/plugins/org.eclipse.wst.common.modulecore:common/plugins/org.eclipse.wst.common.modulecore:g
s:wst/components/common/plugins/org.eclipse.wst.common.project.facet.core:common/plugins/org.eclipse.wst.common.project.facet.core:g
s:wst/components/common/plugins/org.eclipse.wst.common.project.facet.ui:common/plugins/org.eclipse.wst.common.project.facet.ui:g
s:wst/components/common/plugins/org.eclipse.wst.common.snippets:common/plugins/org.eclipse.wst.common.snippets:g
s:wst/components/common/plugins/org.eclipse.wst.common.ui:common/plugins/org.eclipse.wst.common.ui:g
s:wst/components/common/plugins/org.eclipse.wst.common.ui.properties:common/plugins/org.eclipse.wst.common.ui.properties:g
s:wst/components/common/plugins/org.eclipse.wst.common.uriresolver:common/plugins/org.eclipse.wst.common.uriresolver:g
s:wst/components/common/tests/org.eclipse.wst.common.project.facet.core.tests:common/tests/org.eclipse.wst.common.project.facet.core.tests:g
s:wst/components/common/tests/org.eclipse.wst.common.project.facet.ui.tests:common/tests/org.eclipse.wst.common.project.facet.ui.tests:g
s:wst/components/common/tests/org.eclipse.wst.common.snippets.tests:common/tests/org.eclipse.wst.common.snippets.tests:g
s:wst/components/common/tests/org.eclipse.wst.common.tests:common/tests/org.eclipse.wst.common.tests:g
s:wst/components/common/tests/org.eclipse.wst.common.tests.collector:common/tests/org.eclipse.wst.common.tests.collector:g
s:wst/components/common/tests/org.eclipse.wst.common.tests.ui:common/tests/org.eclipse.wst.common.tests.ui:g
s:wst/components/css/plugins/org.eclipse.wst.css.core:sourceediting/plugins/org.eclipse.wst.css.core:g
s:wst/components/css/plugins/org.eclipse.wst.css.ui:sourceediting/plugins/org.eclipse.wst.css.ui:g
s:wst/components/css/tests/org.eclipse.wst.css.core.tests:sourceediting/tests/org.eclipse.wst.css.core.tests:g
s:wst/components/css/tests/org.eclipse.wst.css.tests.encoding:sourceediting/tests/org.eclipse.wst.css.tests.encoding:g
s:wst/components/css/tests/org.eclipse.wst.css.ui.tests:sourceediting/tests/org.eclipse.wst.css.ui.tests:g
s:wst/components/css/tests/org.eclipse.wst.css.ui.tests.performance:sourceediting/tests/org.eclipse.wst.css.ui.tests.performance:g
s:wst/components/doc/features/org.eclipse.wst.doc.isv.feature:webtools.releng/features/org.eclipse.wst.doc.isv.feature:g
s:wst/components/doc/features/org.eclipse.wst.doc.user.feature:webtools.releng/features/org.eclipse.wst.doc.user.feature:g
s:wst/components/doc/plugins/org.eclipse.wst.command.env.doc.user:common/docs/org.eclipse.wst.command.env.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.command.env.infopop:common/docs/org.eclipse.wst.command.env.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.common.infopop:common/plugins/org.eclipse.wst.common.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.datatools.connection.ui.doc.user:datatools/docs/org.eclipse.wst.datatools.connection.ui.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.datatools.data.ui.doc.user:datatools/docs/org.eclipse.wst.datatools.data.ui.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.datatools.fe.ui.doc.user:datatools/docs/org.eclipse.wst.datatools.fe.ui.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.datatools.server.ui.doc.user:datatools/docs/org.eclipse.wst.datatools.server.ui.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.doc.isv:webtools.releng/docs/org.eclipse.wst.doc.isv:g
s:wst/components/doc/plugins/org.eclipse.wst.doc.isv/org.eclipse.wst.doc.isv:webtools.releng/docs/org.eclipse.wst.doc.isv/org.eclipse.wst.doc.isv:g
s:wst/components/doc/plugins/org.eclipse.wst.doc.user:webtools.releng/docs/org.eclipse.wst.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.dtd.ui.infopop:sourceediting/docs/org.eclipse.wst.dtd.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.dtdeditor.doc.user:sourceediting/docs/org.eclipse.wst.dtdeditor.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.html.ui.infopop:sourceediting/docs/org.eclipse.wst.html.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.internet.proxy.infopop:common/archive/org.eclipse.wst.internet.proxy.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.javascript.ui.infopop:sourceediting/docs/org.eclipse.wst.javascript.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.rdb.connection.ui.infopop:datatools/docs/org.eclipse.wst.rdb.connection.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.rdb.fe.ui.infopop:datatools/docs/org.eclipse.wst.rdb.fe.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.rdb.outputview.infopop:datatools/docs/org.eclipse.wst.rdb.outputview.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.rdb.server.ui.infopop:datatools/docs/org.eclipse.wst.rdb.server.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.rdb.sqleditor.infopop:datatools/docs/org.eclipse.wst.rdb.sqleditor.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.server.ui.doc.user:servertools/docs/org.eclipse.wst.server.ui.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.server.ui.infopop:servertools/docs/org.eclipse.wst.server.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.sqleditor.doc.user:datatools/docs/org.eclipse.wst.sqleditor.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.sse.doc.user:sourceediting/docs/org.eclipse.wst.sse.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.sse.ui.infopop:sourceediting/docs/org.eclipse.wst.sse.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.validation.infopop:common/docs/org.eclipse.wst.validation.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.web.ui.infopop:jeetools/docs/org.eclipse.wst.web.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.webtools.doc.user:webtools.releng/docs/org.eclipse.wst.webtools.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.ws.infopop:webservices/docs/org.eclipse.wst.ws.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.wsdl.ui.doc.user:webservices/docs/org.eclipse.wst.wsdl.ui.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.wsi.ui.doc.user:webservices/docs/org.eclipse.wst.wsi.ui.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.xml.ui.infopop:sourceediting/docs/org.eclipse.wst.xml.ui.infopop:g
s:wst/components/doc/plugins/org.eclipse.wst.xmleditor.doc.user:sourceediting/docs/org.eclipse.wst.xmleditor.doc.user:g
s:wst/components/doc/plugins/org.eclipse.wst.xsdeditor.doc.user:sourceediting/docs/org.eclipse.wst.xsdeditor.doc.user:g
s:wst/components/dtd/plugins/org.eclipse.wst.dtd.core:sourceediting/plugins/org.eclipse.wst.dtd.core:g
s:wst/components/dtd/plugins/org.eclipse.wst.dtd.ui:sourceediting/plugins/org.eclipse.wst.dtd.ui:g
s:wst/components/dtd/tests/org.eclipse.wst.dtd.ui.tests:sourceediting/tests/org.eclipse.wst.dtd.ui.tests:g
s:wst/components/html/plugins/org.eclipse.wst.html.core:sourceediting/plugins/org.eclipse.wst.html.core:g
s:wst/components/jsdt/integrate/org.eclipse.wst.html.core:sourceediting/integrate/org.eclipse.wst.html.core:g
s:wst/components/html/plugins/org.eclipse.wst.html.ui:sourceediting/plugins/org.eclipse.wst.html.ui:g
s:wst/components/jsdt/integrate/org.eclipse.wst.html.ui:sourceediting/integrate/org.eclipse.wst.html.ui:g
s:wst/components/html/tests/org.eclipse.wst.html.core.tests:sourceediting/tests/org.eclipse.wst.html.core.tests:g
s:wst/components/html/tests/org.eclipse.wst.html.tests.encoding:sourceediting/tests/org.eclipse.wst.html.tests.encoding:g
s:wst/components/html/tests/org.eclipse.wst.html.ui.tests:sourceediting/tests/org.eclipse.wst.html.ui.tests:g
s:wst/components/html/tests/org.eclipse.wst.html.ui.tests.performance:sourceediting/tests/org.eclipse.wst.html.ui.tests.performance:g
s:wst/components/internet/plugins/org.eclipse.wst.internet.cache:common/plugins/org.eclipse.wst.internet.cache:g
s:wst/components/internet/plugins/org.eclipse.wst.internet.monitor.core:servertools/plugins/org.eclipse.wst.internet.monitor.core:g
s:wst/components/internet/plugins/org.eclipse.wst.internet.monitor.ui:servertools/plugins/org.eclipse.wst.internet.monitor.ui:g
s:wst/components/internet/plugins/org.eclipse.wst.internet.proxy:common/archive/org.eclipse.wst.internet.proxy:g
s:wst/components/internet/tests/org.eclipse.wst.internet.cache.tests:common/tests/org.eclipse.wst.internet.cache.tests:g
s:wst/components/internet/tests/org.eclipse.wst.internet.monitor.core.tests:servertools/tests/org.eclipse.wst.internet.monitor.core.tests:g
s:wst/components/internet/tests/org.eclipse.wst.internet.monitor.ui.tests:servertools/tests/org.eclipse.wst.internet.monitor.ui.tests:g
s:wst/components/javascript/plugins/org.eclipse.wst.javascript.core:sourceediting/plugins/org.eclipse.wst.javascript.core:g
s:wst/components/javascript/plugins/org.eclipse.wst.javascript.ui:sourceediting/plugins/org.eclipse.wst.javascript.ui:g
s:wst/components/jsdt/integrate/org.eclipse.wst.javascript.ui:sourceediting/integrate/org.eclipse.wst.javascript.ui:g
s:wst/components/jsdt/features/org.eclipse.wst.jsdt.feature:sourceediting/features/org.eclipse.wst.jsdt.feature:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.core:sourceediting/plugins/org.eclipse.wst.jsdt.core:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.doc:sourceediting/docs/org.eclipse.wst.jsdt.doc:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.manipulation:sourceediting/plugins/org.eclipse.wst.jsdt.manipulation:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.support.firefox:sourceediting/plugins/org.eclipse.wst.jsdt.support.firefox:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.support.ie:sourceediting/plugins/org.eclipse.wst.jsdt.support.ie:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.ui:sourceediting/plugins/org.eclipse.wst.jsdt.ui:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.web.core:sourceediting/plugins/org.eclipse.wst.jsdt.web.core:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.web.support.jsp:sourceediting/plugins/org.eclipse.wst.jsdt.web.support.jsp:g
s:wst/components/jsdt/plugins/org.eclipse.wst.jsdt.web.ui:sourceediting/plugins/org.eclipse.wst.jsdt.web.ui:g
s:wst/components/rdb/features/org.eclipse.wst.rdb_adapters.feature:datatools/features/org.eclipse.wst.rdb_adapters.feature:g
s:wst/components/rdb/features/org.eclipse.wst.rdb_core.feature:datatools/features/org.eclipse.wst.rdb_core.feature:g
s:wst/components/rdb/features/org.eclipse.wst.rdb_core.feature.patch:datatools/features/org.eclipse.wst.rdb_core.feature.patch:g
s:wst/components/rdb/features/org.eclipse.wst.rdb_sdk.feature:datatools/features/org.eclipse.wst.rdb_sdk.feature:g
s:wst/components/rdb/features/org.eclipse.wst.rdb_tests.feature:datatools/features/org.eclipse.wst.rdb_tests.feature:g
s:wst/components/rdb/features/org.eclipse.wst.rdb_ui.feature:datatools/features/org.eclipse.wst.rdb_ui.feature:g
s:wst/components/rdb/features/org.eclipse.wst.rdb_ui.feature.patch:datatools/features/org.eclipse.wst.rdb_ui.feature.patch:g
s:wst/components/rdb/features/org.eclipse.wst.rdb_userdoc.feature:datatools/features/org.eclipse.wst.rdb_userdoc.feature:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.connection.ui:datatools/plugins/org.eclipse.wst.rdb.connection.ui:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.core:datatools/plugins/org.eclipse.wst.rdb.core:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.core.ui:datatools/plugins/org.eclipse.wst.rdb.core.ui:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.data.core:datatools/plugins/org.eclipse.wst.rdb.data.core:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.data.ui:datatools/plugins/org.eclipse.wst.rdb.data.ui:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.db2.iseries:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.db2.iseries:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.db2.luw:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.db2.luw:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.db2.zseries:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.db2.zseries:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.derby:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.derby:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.generic.jdbc:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.generic.jdbc:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.informix:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.informix:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.mysql:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.mysql:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.oracle:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.oracle:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.sqlserver:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.sqlserver:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.dbdefinition.sybase:datatools/plugins/org.eclipse.wst.rdb.dbdefinition.sybase:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.derby:datatools/plugins/org.eclipse.wst.rdb.derby:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.derby.ui:datatools/plugins/org.eclipse.wst.rdb.derby.ui:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.fe.ui:datatools/plugins/org.eclipse.wst.rdb.fe.ui:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.fe.ui.actions:datatools/plugins/org.eclipse.wst.rdb.fe.ui.actions:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.models.dbdefinition:datatools/plugins/org.eclipse.wst.rdb.models.dbdefinition:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.models.sql:datatools/plugins/org.eclipse.wst.rdb.models.sql:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.models.sql.edit:datatools/plugins/org.eclipse.wst.rdb.models.sql.edit:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.mysql:datatools/plugins/org.eclipse.wst.rdb.mysql:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.outputview:datatools/plugins/org.eclipse.wst.rdb.outputview:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.server.extensions:datatools/plugins/org.eclipse.wst.rdb.server.extensions:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.server.ui:datatools/plugins/org.eclipse.wst.rdb.server.ui:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.sqleditor:datatools/plugins/org.eclipse.wst.rdb.sqleditor:g
s:wst/components/rdb/plugins/org.eclipse.wst.rdb.sqlscrapbook:datatools/plugins/org.eclipse.wst.rdb.sqlscrapbook:g
s:wst/components/rdb/tests/org.eclipse.wst.rdb.tests.dbdefinition:datatools/tests/org.eclipse.wst.rdb.tests.dbdefinition:g
s:wst/components/rdb/tests/org.eclipse.wst.rdb.tests.performance:datatools/tests/org.eclipse.wst.rdb.tests.performance:g
s:wst/components/server/features/org.eclipse.wst.server_adapters.feature:servertools/features/org.eclipse.wst.server_adapters.feature:g
s:wst/components/server/features/org.eclipse.wst.server_adapters.sdk.feature:servertools/features/org.eclipse.wst.server_adapters.sdk.feature:g
s:wst/components/server/features/org.eclipse.wst.server_core.feature:servertools/features/org.eclipse.wst.server_core.feature:g
s:wst/components/server/features/org.eclipse.wst.server_core.feature.patch:servertools/features/org.eclipse.wst.server_core.feature.patch:g
s:wst/components/server/features/org.eclipse.wst.server_sdk.feature:servertools/features/org.eclipse.wst.server_sdk.feature:g
s:wst/components/server/features/org.eclipse.wst.server_tests.feature:servertools/features/org.eclipse.wst.server_tests.feature:g
s:wst/components/server/features/org.eclipse.wst.server_ui.feature:servertools/features/org.eclipse.wst.server_ui.feature:g
s:wst/components/server/features/org.eclipse.wst.server_userdoc.feature:servertools/features/org.eclipse.wst.server_userdoc.feature:g
s:wst/components/server/plugins/org.eclipse.wst.server.core:servertools/plugins/org.eclipse.wst.server.core:g
s:wst/components/server/plugins/org.eclipse.wst.server.http.core:servertools/plugins/org.eclipse.wst.server.http.core:g
s:wst/components/server/plugins/org.eclipse.wst.server.http.ui:servertools/plugins/org.eclipse.wst.server.http.ui:g
s:wst/components/server/plugins/org.eclipse.wst.server.preview:servertools/plugins/org.eclipse.wst.server.preview:g
s:wst/components/server/plugins/org.eclipse.wst.server.preview.adapter:servertools/plugins/org.eclipse.wst.server.preview.adapter:g
s:wst/components/server/plugins/org.eclipse.wst.server.ui:servertools/plugins/org.eclipse.wst.server.ui:g
s:wst/components/server/tests/org.eclipse.wst.server.core.tests:servertools/tests/org.eclipse.wst.server.core.tests:g
s:wst/components/server/tests/org.eclipse.wst.server.http.core.tests:servertools/tests/org.eclipse.wst.server.http.core.tests:g
s:wst/components/server/tests/org.eclipse.wst.server.tests.performance:servertools/tests/org.eclipse.wst.server.tests.performance:g
s:wst/components/server/tests/org.eclipse.wst.server.ui.tests:servertools/tests/org.eclipse.wst.server.ui.tests:g
s:wst/components/sse/plugins/org.eclipse.wst.sse.core:sourceediting/plugins/org.eclipse.wst.sse.core:g
s:wst/components/sse/plugins/org.eclipse.wst.sse.ui:sourceediting/plugins/org.eclipse.wst.sse.ui:g
s:wst/components/sse/tests/org.eclipse.wst.sse.core.tests:sourceediting/tests/org.eclipse.wst.sse.core.tests:g
s:wst/components/sse/tests/org.eclipse.wst.sse.ui.tests:sourceediting/tests/org.eclipse.wst.sse.ui.tests:g
s:wst/components/sse/tests/org.eclipse.wst.sse.ui.tests.performance:sourceediting/tests/org.eclipse.wst.sse.ui.tests.performance:g
s:wst/components/validation/plugins/org.eclipse.wst.validation:common/plugins/org.eclipse.wst.validation:g
s:wst/components/validation/plugins/org.eclipse.wst.validation.ui:common/plugins/org.eclipse.wst.validation.ui:g
s:wst/components/web/features/org.eclipse.wst.web_core.feature:jeetools/features/org.eclipse.wst.web_core.feature:g
s:wst/components/web/features/org.eclipse.wst.web_core.feature.patch:jeetools/features/org.eclipse.wst.web_core.feature.patch:g
s:wst/components/web/features/org.eclipse.wst.web_sdk.feature:jeetools/features/org.eclipse.wst.web_sdk.feature:g
s:wst/components/web/features/org.eclipse.wst.web_tests.feature:jeetools/features/org.eclipse.wst.web_tests.feature:g
s:wst/components/web/features/org.eclipse.wst.web_ui.feature:jeetools/features/org.eclipse.wst.web_ui.feature:g
s:wst/components/web/features/org.eclipse.wst.web_userdoc.feature:jeetools/features/org.eclipse.wst.web_userdoc.feature:g
s:wst/components/web/plugins/org.eclipse.wst.standard.schemas:sourceediting/plugins/org.eclipse.wst.standard.schemas:g
s:wst/components/web/plugins/org.eclipse.wst.web:jeetools/plugins/org.eclipse.wst.web:g
s:wst/components/web/plugins/org.eclipse.wst.web.ui:jeetools/plugins/org.eclipse.wst.web.ui:g
s:wst/components/ws/features/org.eclipse.wst.ws_core.feature:webservices/features/org.eclipse.wst.ws_core.feature:g
s:wst/components/ws/features/org.eclipse.wst.ws_sdk.feature:webservices/features/org.eclipse.wst.ws_sdk.feature:g
s:wst/components/ws/features/org.eclipse.wst.ws_tests.feature:webservices/features/org.eclipse.wst.ws_tests.feature:g
s:wst/components/ws/features/org.eclipse.wst.ws_ui.feature:webservices/features/org.eclipse.wst.ws_ui.feature:g
s:wst/components/ws/features/org.eclipse.wst.ws_userdoc.feature:webservices/features/org.eclipse.wst.ws_userdoc.feature:g
s:wst/components/ws/plugins/org.eclipse.wst.ws:webservices/plugins/org.eclipse.wst.ws:g
s:wst/components/ws/plugins/org.eclipse.wst.ws.explorer:webservices/plugins/org.eclipse.wst.ws.explorer:g
s:wst/components/ws/plugins/org.eclipse.wst.ws.parser:webservices/plugins/org.eclipse.wst.ws.parser:g
s:wst/components/ws/plugins/org.eclipse.wst.ws.service.policy.ui:webservices/plugins/org.eclipse.wst.ws.service.policy.ui:g
s:wst/components/ws/plugins/org.eclipse.wst.ws.ui:webservices/plugins/org.eclipse.wst.ws.ui:g
s:wst/components/ws/tests/org.eclipse.wst.ws.tests:webservices/tests/org.eclipse.wst.ws.tests:g
s:wst/components/ws/thirdparty/org.apache.axis:webservices/archive/thirdparty/org.apache.axis:g
s:wst/components/ws/thirdparty/org.apache.commons_logging:webservices/archive/thirdparty/org.apache.commons_logging:g
s:wst/components/ws/thirdparty/org.apache.jakarta_log4j:webservices/archive/thirdparty/org.apache.jakarta_log4j:g
s:wst/components/ws/thirdparty/org.apache.wsil4j:webservices/archive/thirdparty/org.apache.wsil4j:g
s:wst/components/ws/thirdparty/org.uddi4j:webservices/archive/thirdparty/org.uddi4j:g
s:wst/components/wsdl/plugins/org.eclipse.wst.wsdl:webservices/plugins/org.eclipse.wst.wsdl:g
s:wst/components/wsdl/plugins/org.eclipse.wst.wsdl.ui:webservices/plugins/org.eclipse.wst.wsdl.ui:g
s:wst/components/wsdl/plugins/org.eclipse.wst.wsdl.validation:webservices/plugins/org.eclipse.wst.wsdl.validation:g
s:wst/components/wsdl/tests/org.eclipse.wst.wsdl.tests:webservices/tests/org.eclipse.wst.wsdl.tests:g
s:wst/components/wsdl/tests/org.eclipse.wst.wsdl.tests.performance:webservices/tests/org.eclipse.wst.wsdl.tests.performance:g
s:wst/components/wsdl/tests/org.eclipse.wst.wsdl.tests.ui:webservices/tests/org.eclipse.wst.wsdl.tests.ui:g
s:wst/components/wsdl/tests/org.eclipse.wst.wsdl.validation.tests:webservices/tests/org.eclipse.wst.wsdl.validation.tests:g
s:wst/components/wsdl/thirdparty/org.wsdl4j:webservices/archive/thirdparty/org.wsdl4j:g
s:wst/components/wsi/plugins/org.eclipse.wst.wsi:webservices/plugins/org.eclipse.wst.wsi:g
s:wst/components/wsi/plugins/org.eclipse.wst.wsi.ui:webservices/plugins/org.eclipse.wst.wsi.ui:g
s:wst/components/wsi/tests/org.eclipse.wst.wsi.tests:webservices/tests/org.eclipse.wst.wsi.tests:g
s:wst/components/xml/features/org.eclipse.wst.xml_core.feature:sourceediting/features/org.eclipse.wst.xml_core.feature:g
s:wst/components/xml/features/org.eclipse.wst.xml_sdk.feature:sourceediting/features/org.eclipse.wst.xml_sdk.feature:g
s:wst/components/xml/features/org.eclipse.wst.xml_tests.feature:sourceediting/features/org.eclipse.wst.xml_tests.feature:g
s:wst/components/xml/features/org.eclipse.wst.xml_ui.feature:sourceediting/features/org.eclipse.wst.xml_ui.feature:g
s:wst/components/xml/features/org.eclipse.wst.xml_ui.feature.patch:sourceediting/features/org.eclipse.wst.xml_ui.feature.patch:g
s:wst/components/xml/features/org.eclipse.wst.xml_userdoc.feature:sourceediting/features/org.eclipse.wst.xml_userdoc.feature:g
s:wst/components/xml/plugins/org.eclipse.wst.xml.core:sourceediting/plugins/org.eclipse.wst.xml.core:g
s:wst/components/xml/plugins/org.eclipse.wst.xml.ui:sourceediting/plugins/org.eclipse.wst.xml.ui:g
s:wst/components/xml/tests/org.eclipse.wst.xml.core.tests:sourceediting/tests/org.eclipse.wst.xml.core.tests:g
s:wst/components/xml/tests/org.eclipse.wst.xml.tests.encoding:sourceediting/tests/org.eclipse.wst.xml.tests.encoding:g
s:wst/components/xml/tests/org.eclipse.wst.xml.ui.tests:sourceediting/tests/org.eclipse.wst.xml.ui.tests:g
s:wst/components/xml/tests/org.eclipse.wst.xml.ui.tests.performance:sourceediting/tests/org.eclipse.wst.xml.ui.tests.performance:g
s:wst/components/xml/tests/org.eclipse.wst.xml.validation.tests:sourceediting/tests/org.eclipse.wst.xml.validation.tests:g
s:wst/components/xml/thirdparty/org.apache.xerces:sourceediting/archive/thirdparty/org.apache.xerces:g
s:wst/components/xml/thirdparty/org.apache.xerces.feature:sourceediting/archive/thirdparty/org.apache.xerces.feature:g
s:wst/components/xsd/plugins/org.eclipse.wst.xsd.core:sourceediting/plugins/org.eclipse.wst.xsd.core:g
s:wst/components/xsd/plugins/org.eclipse.wst.xsd.ui:sourceediting/plugins/org.eclipse.wst.xsd.ui:g
s:wst/components/xsd/tests/org.eclipse.wst.xsd.tests.performance:sourceediting/tests/org.eclipse.wst.xsd.tests.performance:g
s:wst/components/xsd/tests/org.eclipse.wst.xsd.validation.tests:sourceediting/tests/org.eclipse.wst.xsd.validation.tests:g