#!/usr/bin/env bash
PIDFILE=cc.pid
echo;
if [ -f ${PIDFILE} ] ; then
  echo "    Killing CC process from PID file"
  PID=`cat ${PIDFILE}`
  kill -3 $PID
  # if permission denied, for example, then be sure not to remove PID file
  if [ $? ] 
  then
	  if kill -9 $PID ; then
	    echo "    CC process stopped"
	    rm -f ${PIDFILE}
	  else
	    echo "    CC process could not be stopped"
	  fi
  else
    echo "    Could not kill the process."  
  fi
else
	echo "    PID file (${PIDFILE}) does not exist."
	echo "        Either CC not running, or PID file deleted"
fi
echo;

./xvfb-stop.sh
